
import java.awt.Desktop;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Enumeration;

import org.apache.tools.zip.ZipEntry;
import org.apache.tools.zip.ZipFile;
import org.apache.tools.zip.ZipOutputStream;


/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
/**
 * Zip解凍する
 * 
 * java work.UnZip [入力ファイル名]
 * 
 * @author Kentarou Yamane さんのを改変しました。ダチョウ
 */
public class UnZip {


	/**
	 * Zipの圧縮、解凍を行います
	 * 
	 * @param args
	 *            解凍；圧縮オプション　文字コード　入力元　出力先フォルダ
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		String help="<Unizipper Console>\n"+
					"本ソフトは異なるOS間、文字コードに関わらずZIPファイルの作成、解凍を行うものです\n"+
					"構文は次のようになっています\n\n"+
					"\t java -jar unizipper [解凍か圧縮か] [文字コード] [入力元フォルダ(圧縮時)、もしくはファイル(解凍時)] [出力先ファイル(圧縮時)、もしくはフォルダ(解凍時)]\n\n"+
					"なお、出力先は省略可能です。この場合ZIPは[入力元名＋.zip]として、展開フォルダは[入力元名から拡張子を除いたもの]としてカレントディレクトリに作成されます。"+
					"使用例：\n\n"+
					"\t [解凍時]java -jar unizipper.jar ex shift-JIS /root/hoge.zip /root/hoge\n"+
					"\t [圧縮時]java -jar unizipper.jar mk UTF-8 /root/hoge /root/hoge.zip\n\n"+
					"<全オプション>\n"+
					"[解凍か圧縮か]ex,mk [文字コード]UTF-8,shift-JIS,MS932,EUC-JP,ISO2022JP";
		String codes =  (",UTF-8,shift-JIS,MS932,EUC-JP,ISO2022JP,");
		if(args.length<3){System.out.println("パラメータがたりません");System.out.println(help);return;}
		if(args[0].equals("-h")){System.out.println(help);return;}
		
		//エラー事前チェック
		if(!args[0].equals("ex")&&!args[0].equals("mk")){System.out.println("解凍、圧縮オプションが間違っています");System.out.println(help);return;}
		if(!codes.contains(","+args[1]+",")){System.out.println("文字コードのオプションが間違っています");System.out.println(help);return;}
		File inputf = new File(args[2]);
		if(!inputf.exists()){System.out.println("入力元ファイル、もしくはフォルダが存在していません");System.out.println("指定された入力元>"+args[2]);System.out.println(help);return;}
		
		//出力先は省略可能
		File openfile = null;
		if(args.length==4){
		 if(args[0].equals("ex")) proccessUnZip2(args[2], args[3]+"/", args[1]);
		 if(args[0].equals("mk"))makezip(inputf, args[3], args[1]);
		 openfile = new File(new File(args[3]).getAbsoluteFile().getParent());
		}
		if(args.length==3){
			 if(args[0].equals("ex"))proccessUnZip2(args[2],inputf.getName().substring(0,inputf.getName().lastIndexOf('.'))+"/", args[1]);
			 if(args[0].equals("mk"))makezip(inputf,inputf.getName()+".zip", args[1]);
			 openfile=new File(System.getProperty("user.dir"));
		}
		
		//終了メッセージ
		System.out.println("Unizipper終了しました");
		if (!Desktop.isDesktopSupported())return;
		try {
			System.out.println("ファイルが作成された、もしくは展開された場所を開きます＞"+openfile.getPath());
			Desktop.getDesktop().open(openfile);
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
	}
	

	/**
	 * 圧縮ーzipファイルに対象ファルダ以下の構造樹を再帰的に追加
	 * 
	 * @param zos
	 *            ZIPファイルへの書き込みストリーム。指定の必要無
	 * @param files
	 *            対象ファルダの内容物。フォルダとファイルの場合がある
	 * @param targetdir
	 *            圧縮されるROOTフォルダ。追加対象となったファイルの絶対パスからこれを差し引き、相対パスでエントリに追加する
	 * 
	 */
	static void encode(ZipOutputStream zos, File[] files, File targetdir)throws Exception {
		for (File f : files) {
			if (f.isDirectory()) {
				encode(zos, f.listFiles(), targetdir);
			} else {
				// 選択ディレクトリ以下(parentにより未満ではない)でエントリー作成（解凍時に散らばらない）
				// ex. /a/ab/a (target ab)> ab/a
				ZipEntry ze = new ZipEntry(f.getPath().replace('\\', '/').substring(targetdir.getParent().length() + 1));// "/"のため
				System.out.println(ze.getName());
				zos.putNextEntry(ze);
				InputStream is = new BufferedInputStream(new FileInputStream(f));
				for (;;) {
					int len = is.read(buf);
					if (len < 0)
						break;
					zos.write(buf, 0, len);
				}
				is.close();
			}
		}
	}

	/**
	 * ZIPファイルの作成スクリプト
	 * 
	 * @param targetdir
	 *            一つのZIP圧縮されるディレクトリ
	 * @param out
	 *            作成されるZIPファイルの名前（拡張子を含む）
	 * @param encodestring
	 *            圧縮先ZIPの内部文字コード
	 */
	public static void makezip(File targetdir, String out, String encodestring)throws FileNotFoundException, IOException {
		System.out.println("Zipファイルの作成を試みます：["+encodestring+"] "+targetdir+">"+out);
		File zipf = new File(out); // 作成するzipファイルの名前
		new File(zipf.getAbsolutePath()).getParentFile().mkdirs();//親フォルダまで作成しておく
		File[] files = { targetdir };
		// 圧縮対象を相対パスで指定
		ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(zipf));
		zos.setEncoding(encodestring); // Ant版のみ
		try {
			try {
				encode(zos, files, targetdir);
			} catch (Exception e) {
				e.printStackTrace();
			}
		} finally {
			zos.close();
		}
	}

	static byte[] buf = new byte[1024];


	/**
	 * zipファイルの解凍を行います
	 * 
	 * @param filename
	 *            解凍されるzipファイル
	 * @param outfile
	 *            解凍時に作成されるファルダ名。このフォルダ以下に展開する
	 * @param encode
	 *            zip エンコード
	 * 
	 */
	private static void proccessUnZip2(String filename, String outfile,String encode) throws IOException {
		System.out.println("Zipの解凍を試みます：["+encode+"] "+filename+">"+outfile);
		new File(outfile).mkdir();
		ZipFile zipFile = new ZipFile(filename, encode);
		Enumeration enumeration = zipFile.getEntries();
		while (enumeration.hasMoreElements()) {
			ZipEntry entry = (ZipEntry) enumeration.nextElement();
			System.out.println(entry);
			if (entry.isDirectory()) {
				new File(outfile + entry.getName()).mkdirs();
			} else {
				File parent = new File(outfile + entry.getName()).getParentFile();
				parent.mkdirs();
				FileOutputStream out = new FileOutputStream(outfile+ entry.getName());
				InputStream in = zipFile.getInputStream(entry);
				byte[] buf = new byte[1024];
				int size = 0;
				while ((size = in.read(buf)) != -1) {
					out.write(buf, 0, size);
				}
				out.close();
			}
		}
	}
}
